Subject: Re: [PATCH 0/5] git son: add command to create independent child repositories

From: Junio C Hamano <[email-masked]>
Date: Mon, 01 Jun 2026 14:33:10 +0900

"Evan Haque via GitGitGadget" <[email-masked]> writes:

> Motivation
> ==========
>
> When spinning off a new project that is related to an existing repository,
> there is no built-in way to create a child repository that maintains a link
> back to its parent without the tight coupling of submodules. Submodules pin
> the child to a specific commit and require the parent to track the child in
> its index, which is too heavyweight when the child is meant to be fully
> independent.
>
> The typical workflow today is manual: git init, git remote add, update
> .gitignore — three steps that are easy to forget or get wrong. git son
> automates this and establishes a lightweight convention for the parent-child
> relationship: a remote named parent in the child, and nothing in the parent
> except an ignore rule.

Although I am personally not interested in this topic even for local
repository use, I should point out that using this tool to create
this combination of repositories would not be useful for other
people who want to clone your arrangement. Other than leaving
comments in the parent project, there seems to be no way to specify
how or where the child projects should be cloned within the working
tree of the parent project.

Since Git is primarily a tool for collaboration among people with
their own repositories, I fail see how this feature is something we
should ship to all Git users as part of the core distribution.

Thanks.